package com.sap.ms.em.minihub.camel.consumer;


import javax.naming.AuthenticationException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

public class IOTConsole {
	
	
	  public static final void main(String... aArgs) throws IOException{

		Properties prop = new Properties();
		InputStream input = null;

		try {

	    		String filename = "app.properties";
	    		input = IOTConsole.class.getClassLoader().getResourceAsStream(filename);
	    		if(input==null){
	    	            System.out.println("Sorry, unable to find " + filename);
	    		}

	    		//load a properties file from class path, inside static method
	    		prop.load(input);
	    	    if (prop.getProperty("setProxy").equalsIgnoreCase("true")) {
	    	        // HTTP/HTTPS Proxy
	    	        System.setProperty("http.proxyHost", prop.getProperty("http.proxyHost"));
	    	        System.setProperty("http.proxyPort", prop.getProperty("http.proxyPort"));
	    	        System.setProperty("https.proxyHost", prop.getProperty("https.proxyHost"));
	    	        System.setProperty("https.proxyPort", prop.getProperty("https.proxyPort"));
	    	        
	    	        System.setProperty("java.net.useSystemProxies", "true");
	    	        System.out.println("Use the proxy");
	    	    }
	        MakeIOTJson.setAppToken(prop.getProperty("applicationToken"));
                MakeIOTJson.setBaseUrl(prop.getProperty("baseUrl"));

		} catch (IOException ex) {
	    		ex.printStackTrace();
	    } finally{
	        	if(input!=null){
	        		try {
					input.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
	        	}
	    }
                System.out.println("Use the proxy");
		while (true) {
			BufferedReader standardInput
		    		= new BufferedReader(new InputStreamReader(System.in));
			System.out.println("---------Main Menu--------");
		    System.out.println("1. Endpoint");
		    System.out.println("2. SIM");
		    System.out.println("3. Events");
		    System.out.println("4. ServiceLookup");
		    System.out.println("5. Exit\n");
		    
			System.out.print("Enter your choice: ");
				
			String choice = standardInput.readLine();
			
			if (choice.trim().equals("1")) {
				EndpointOp();
			} else if (choice.trim().equals("2")) {
				SimOp();
			} else if (choice.trim().equals("3")) {
				EventOp(); 
			} else if (choice.trim().equals("4")) {
				LookupOp();
			} else if (choice.trim().equals("5")) {
				System.exit(0);
			}
		  }
	  }

	  private static void EndpointOp()  {
		  
		  Boolean loop = true;
		  
		  while (loop) {
			BufferedReader standardInput
			    = new BufferedReader(new InputStreamReader(System.in));
			System.out.println("------------Endpoint---------------");
		    System.out.println("1. Create Endpoint");
		    System.out.println("2. Delete Endpoint By ID");
		    System.out.println("3. Retrive Endpoint By ID");
		    System.out.println("4. Retrive Endpoint By Name");
		    System.out.println("5. Update Endpoint By ID");
		    System.out.println("6. Goto Main Menu\n");
		    
			System.out.print("Endpoint :: Enter your choice: ");

			
			String choice;
			try {
				choice = standardInput.readLine();
				
				if (choice.trim().equals("1")) {
					Map<String, String> NVPare = new HashMap<String, String>();
					System.out.print("Enter the name (required):");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String name = makeValue(standardInput.readLine(), false);
					if (name != null) {
						NVPare.put("name", name);
					}
					
					System.out.print("Enter the status (required) 0 Enable, 1 Disable:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String status = standardInput.readLine();
					if (status != null && !status.trim().isEmpty()) {
						status = "{ \"id\":" +status+ " }";
						NVPare.put("status", status);
					}
					
					System.out.print("Enter the service profile (required):");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String service_profile = makeValue(standardInput.readLine(), true);
					if (service_profile != null) {
						NVPare.put("service_profile", service_profile);
					}
					
					System.out.print("Enter the tariff profile (required):");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String tariff_profile = makeValue(standardInput.readLine(), true);
					if (tariff_profile != null ) {
						NVPare.put("tariff_profile", tariff_profile);
					}
					
					System.out.print("Enter the SIM ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String sim = makeValue(standardInput.readLine(), true);
					if (sim != null) {
						NVPare.put("sim", sim);					
					}
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.PostRequest("endpoint", NVPare);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
					
				} else if (choice.trim().equals("2")) {
					System.out.print("Enter the EndpointID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.DeleteRequest("endpoint", choice);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("3")) {
					System.out.print("Enter the EndpointID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("endpoint/", choice);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("4")) {
					System.out.print("Enter the Endpoint Name:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String name  = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("endpoint?", "q=name:"+URLEncoder.encode(name, "UTF-8"));
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("5")) {
					System.out.print("Enter the Endpoint ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String endpointID = standardInput.readLine();
					
					Map<String, String> NVPare = new HashMap<String, String>();
					System.out.print("Enter the name:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String name = makeValue(standardInput.readLine(), false);
					if (name != null) {
						NVPare.put("name", name);
					}
					
					System.out.print("Enter the status (0: Enable, 1: Disalbe):");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String status = standardInput.readLine();
					if (status != null && !status.trim().isEmpty()) {
						status = "{ \"id\":" +status+ " }";
						NVPare.put("status", status);
					}
					System.out.print("Enter the sevice profile:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String service_profile = makeValue(standardInput.readLine(), true);
					if (service_profile != null) {
						NVPare.put("service_profile", service_profile);
					}
					System.out.print("Enter the tariff profile:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String tariff_profile = makeValue(standardInput.readLine(), true);
					if (tariff_profile != null ) {
						NVPare.put("tariff_profile", tariff_profile);
					}
					
					System.out.print("Enter the SIM ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String sim = makeValue(standardInput.readLine(), true);
					if (sim != null) {
						NVPare.put("sim", sim);					
					}
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.PatchRequest("endpoint", endpointID, NVPare);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("6")) {
					loop = false;
					
				}
				
			} catch (IOException e) {

				e.printStackTrace();
			}
		  }
	  }
	  

	  
	  private static void SimOp()  {
		  
		  Boolean loop = true;
		  
		  while (loop) {
			BufferedReader standardInput
			    = new BufferedReader(new InputStreamReader(System.in));
			System.out.println("------------SIM---------------");
		    System.out.println("1. Retrive SIM By ICCID");
		    System.out.println("2. Retrive SIM By ID");
		    System.out.println("3. Activate SIM By ID");
		    System.out.println("4. Suspend SIM By ID");
		    System.out.println("5. Register SIM");
		    System.out.println("6. Goto Main Menu\n");
			System.out.print("SIM :: Enter your choice: ");
			
			String choice;
			try {
				choice = standardInput.readLine();
				
				if (choice.trim().equals("1")) {
					System.out.print("Enter the iccid#:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String iccid = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("sim?", "q=iccid:"+iccid);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}	

				} else if (choice.trim().equals("2")) {
					System.out.print("Enter the SIM ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("sim/", choice);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("3")) {
					System.out.print("Enter the SIM ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					Map<String, String> NVPair = new HashMap<String, String>();
					String	retrunValue = "{ \"id\": 1 }";
					NVPair.put("status", retrunValue);				
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.PatchRequest("sim", choice, NVPair);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("4")) {
					System.out.print("Enter the SIM ID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					Map<String, String> NVPair = new HashMap<String, String>();
					String	retrunValue = "{ \"id\": 2 }";
					NVPair.put("status", retrunValue);
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.PatchRequest("sim", choice, NVPair);
					} catch (AuthenticationException e) {

						e.printStackTrace();
					}
				} else if (choice.trim().equals("5")) {
					System.out.print("Enter the BIC Code without hyphen:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					choice = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.PatchRequest("sim_batch/bic/", choice);
					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
				} else if (choice.trim().equals("6")) {
					loop = false;
				}
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
		  }
	  
	  }
	  
	  
	  private static void EventOp()  {
		  Boolean loop = true;
		  while (loop) {
			BufferedReader standardInput
			    = new BufferedReader(new InputStreamReader(System.in));
			 
			System.out.println("----------------Event--------------------");
		    System.out.println("1. Retrive Events By Endpoint");
		    System.out.println("2. Retrive Events By ICCID");
		    System.out.println("3. Retrive EventTypes");
		    System.out.println("4. Retrive Events By Type");
		    System.out.println("5. Retrive Event By Event ID");
		    System.out.println("6. Goto Main Menu\n");
		    
			System.out.print("Event :: Enter your choice: ");

			
			String choice;
			try {
				choice = standardInput.readLine();
				
				if (choice.trim().equals("1")) {
					System.out.print("Enter the Endpoint Name:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String name = standardInput.readLine();
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("event?", "q=endpoint:"+URLEncoder.encode(name, "UTF-8"));					

					} catch (AuthenticationException e) {
						e.printStackTrace();
					}
				} else if (choice.trim().equals("2")) {
					System.out.print("Enter the ICCID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String iccid = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("event?", "q=iccid:"+iccid);
					} catch (AuthenticationException e) {
						e.printStackTrace();
					}
				} else if (choice.trim().equals("3")) {

					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("event/", "type");
					} catch (AuthenticationException e) {
						e.printStackTrace();
					}
				} else if (choice.trim().equals("4")) {
					System.out.print("Enter the EventType (0 - 10):");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String type = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("event?", "q=type:"+type);
					} catch (AuthenticationException e) {
						e.printStackTrace();
					}
				} else if (choice.trim().equals("5")) {
					System.out.print("Enter the EventID:");
					standardInput = new BufferedReader(new InputStreamReader(System.in));
					String id = standardInput.readLine();
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("event?", "q=id:"+id);
					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
					
				} else if (choice.trim().equals("6")) {
					loop = false;
				}
			} catch (IOException e) {
				
				e.printStackTrace();
			}
		  }

		} 
	  
	  private static void LookupOp()  {
		  
		  boolean loop = true;
		  while (loop) {
			BufferedReader standardInput
			    = new BufferedReader(new InputStreamReader(System.in));
			 
			System.out.println("---------------Lookup-----------------");
			 
		    System.out.println("1. Lookup Available Countries");
		    System.out.println("2. Lookup Available Currencies");
		    System.out.println("3. Lookup Available Data Blocksizes");
		    System.out.println("4. Lookup Available Data Throttles");
		    System.out.println("5. Lookup Available Operators");
		    System.out.println("6. Goto Main Menu\n");
		    
			System.out.print("Lookup :: Enter your choice: ");

			
			String choice;
			try {
				choice = standardInput.readLine();
				
				if (choice.trim().equals("1")) {
					
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("country", "");					

					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
				} else if (choice.trim().equals("2")) {
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("currency", "");					

					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
				} else if (choice.trim().equals("3")) {

					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("data_blocksize", "");
					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
				} else if (choice.trim().equals("4")) {
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("data_throttle", "");
					} catch (AuthenticationException e) {
						
						e.printStackTrace();
					}
				} else if (choice.trim().equals("5")) {
					try {
						if (MakeIOTJson.Token == null)
							MakeIOTJson.authenticate();
						
						MakeIOTJson.GetRequest("operator", "");
					} catch (AuthenticationException e) {
						e.printStackTrace();
					}
				} else if (choice.trim().equals("6")) {
					loop = false;
				}
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
		  }

		} 
	  
	  private static String makeValue(String value, Boolean isInt) {
		  
		String retrunValue = null;
		if (value != null && !value.trim().isEmpty()) {
			
			if (isInt)
				retrunValue = "{ \"id\":" +value+ " }";
			else
				retrunValue = "\"" +value+ "\"";
		}
		return retrunValue;
		
	  }
}

