package com.sap.ms.em.minihub.camel.consumer;

import javax.naming.AuthenticationException;


import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.w3c.dom.*;
import java.io.*;
import java.net.MalformedURLException;
import java.util.Map;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPatch;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;

import org.apache.http.impl.client.HttpClientBuilder;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

public class MakeIOTJson {

	private static MakeIOTJson instance = null;
	private static String ApplicationToken = null;
        private static String BaseUrl = null;
	public static String Token = null;
	protected MakeIOTJson() {

	}
	public static MakeIOTJson getInstnace() {
		if(instance == null) 
	        instance = new MakeIOTJson();
	         

	      return instance;
	}
	
        public static void setBaseUrl(String url) {
		BaseUrl = url;
	}
        
	public static void setAppToken(String token) {
		ApplicationToken = token;
	}
	
	public static void authenticate() throws AuthenticationException, IOException {
		 String jsonText =
	    	      "{\n" + 
	    	      "    \"application_token\": \""+ApplicationToken+"\"\n" + 
	    	      "}"; 
		 
		  try {
				String url = BaseUrl + "/api/v1/authenticate";

			  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
				HttpPost postRequest = new HttpPost(url);   	
				
				StringEntity input = new StringEntity(jsonText);
				input.setContentType("application/json");
				postRequest.setEntity(input);

				System.out.println("Client Header:"+input.toString());
				System.out.println("Client Data:"+jsonText);
				HttpResponse response = httpClient.execute(postRequest);

				if (response.getStatusLine().getStatusCode() != 200) {
					throw new RuntimeException("Failed : HTTP error code : "
						+ response.getStatusLine().getStatusCode());
				}

				BufferedReader br = new BufferedReader(
		                        new InputStreamReader((response.getEntity().getContent())));

				String output;
				StringBuffer resp = new StringBuffer();
				System.out.println("Output from Server .... \n");
				while ((output = br.readLine()) != null) {
					resp.append(output);
				}

				//print result
				System.out.println(toPrettyFormat(resp.toString()));
				//parsing the result
				JSONObject jsonObject = (JSONObject) JSONValue.parse(resp.toString());
			    
				Token =  (String) jsonObject.get("auth_token");
				System.out.println("token :" +Token);
				System.out.println("\n\n");
				
				if (Token == null) 
					throw new AuthenticationException();


			  } catch (MalformedURLException e) {

				  throw e;

			  } catch (IOException e) {

				throw e;

			  }
		
	}
	
	public static void GetRequest(String name, String param) throws AuthenticationException, IOException {
		 
		  try {
				String url = BaseUrl + "/api/v1/"+name+""+param;

			  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
				HttpGet getRequest = new HttpGet(url);
				   	
				getRequest.addHeader("accept", "application/json");
				getRequest.addHeader("Authorization", "Bearer "+Token);

				System.out.println("Sending Data:"+getRequest.toString());
				HttpResponse response = httpClient.execute(getRequest);
				
				if (response.getStatusLine().getStatusCode() == 401)
					throw new AuthenticationException();
				

				BufferedReader br = new BufferedReader(
		                        new InputStreamReader((response.getEntity().getContent())));

				String output;
				StringBuffer resp = new StringBuffer();
				System.out.println("Output from Server .... \n");
				while ((output = br.readLine()) != null) {
					resp.append(output);
				}
				//print result		    
				System.out.println(toPrettyFormat(resp.toString()));

				System.out.println("\n\n");
				
			  } catch (MalformedURLException e) {

				  throw e;

			  } catch (IOException e) {

				throw e;

			  }
		
	}
	
	public static void DeleteRequest(String name, String param) throws AuthenticationException, IOException {
		 

	  try {
			String url = BaseUrl + "/api/v1/"+name+"/"+param;
			System.out.println("url :" +url);

		  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
			HttpDelete getRequest = new HttpDelete(url);
			   	
			getRequest.addHeader("Content-Type", "application/json");
			getRequest.addHeader("Authorization", "Bearer "+Token);

			System.out.println("Sending Data:"+getRequest.toString());
			HttpResponse response = httpClient.execute(getRequest);
			
			if (response.getStatusLine().getStatusCode() == 401)
				throw new AuthenticationException();
			
			System.out.println(response.getStatusLine().getStatusCode());
			System.out.println("\n\n");
			

			
		  } catch (MalformedURLException e) {

			  throw e;

		  } catch (IOException e) {

			throw e;

		  }
	}
	
	
	public static void PatchRequest(String name, String param, Map<String, String> NVPair) throws AuthenticationException, IOException {
 
		 StringBuffer jsonRequest = new StringBuffer();
		 
		 jsonRequest.append("{\n");
		 for (Map.Entry<String, String> entry : NVPair.entrySet()) {
			    jsonRequest.append("\"").append(entry.getKey()).append("\": ").append(entry.getValue()).append(",");			    
		 }
		 jsonRequest.deleteCharAt(jsonRequest.length()-1);
		 jsonRequest.append("\n}");
		 
		 System.out.println("JsonData:"+jsonRequest.toString());
		 try {
				String url = BaseUrl + "/api/v1/"+name+"/"+param;

			  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
				
				HttpPatch patchRequest = new HttpPatch(url);
				   	
				patchRequest.addHeader("Authorization", "Bearer "+Token);
				StringEntity input = new StringEntity(jsonRequest.toString());
				input.setContentType("application/json");
				patchRequest.setEntity(input);
				   	
				System.out.println("Sending Data:"+patchRequest.toString());
				HttpResponse response = httpClient.execute(patchRequest);
				
				if (response.getStatusLine().getStatusCode() == 401)
					throw new AuthenticationException();
				System.out.println(response.getStatusLine().getStatusCode());
				
				System.out.println("\n\n");
				

			  } catch (MalformedURLException e) {

				  throw e;

			  } catch (IOException e) {

				throw e;

			  } 
	}
	
	public static void PatchRequest(String name, String param) throws AuthenticationException, IOException {

		  try {
				String url = BaseUrl + "/api/v1/"+name+"/"+param;

			  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
				
				HttpPatch patchRequest = new HttpPatch(url);
				   	
				patchRequest.addHeader("Authorization", "Bearer "+Token);
				StringEntity input = new StringEntity("");
				input.setContentType("application/json");
				patchRequest.setEntity(input);
				   	
				System.out.println("Sending Data:"+patchRequest.toString());
				HttpResponse response = httpClient.execute(patchRequest);
				
				if (response.getStatusLine().getStatusCode() == 401)
					throw new AuthenticationException();
				
				System.out.println(response.getStatusLine().getStatusCode());
				BufferedReader br = new BufferedReader(
	                       new InputStreamReader((response.getEntity().getContent())));

				String output;
				StringBuffer resp = new StringBuffer();
				System.out.println("Output from Server .... \n");
				while ((output = br.readLine()) != null) {
					resp.append(output);
				}
				//print result
				System.out.println(toPrettyFormat(resp.toString()));
				System.out.println("\n\n");
				
			  } catch (MalformedURLException e) {

				  throw e;

			  } catch (IOException e) {

				throw e;

			  }
	}
	
	public static void PostRequest(String name, Map<String, String> NVPair) throws AuthenticationException, IOException {
		/* String jsonText2 =
			 		"{\n" 
					 + " \"name\": \"android device\",\n"
					 + " \"tags\": \"test, meter, temp\",\n "
					 + " \"status\": {\n"
					 + "     \"id\": 0\n"
					 + "   },\n"
					 + " \"service_profile\": {\n"
					 + "     \"id\": 3792\n"
					 + "   },\n"
					 + " \"tariff_profile\": {\n"
					 + "     \"id\": 2376\n"
					 + "   },\n"
					 + " \"sim\": {\n"
					 + "     \"id\": 339258\n"
					 + "   }\n"
					 + "}\n";
		 String jsonText =
				 "{\n" 
						 + " \"status\": {\n"
						 + "     \"id\": 0\n"
						 + "   },\n"
						 + " \"iccid\": {\n"
						 + "     \"id\": 8988303000000151457\n"
						 + "   }\n"
						 + "}\n"; */
		 StringBuffer jsonRequest = new StringBuffer();
		 
		 jsonRequest.append("{\n");
		 for (Map.Entry<String, String> entry : NVPair.entrySet()) {
			    //System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());
			    jsonRequest.append("\"").append(entry.getKey()).append("\": ").append(entry.getValue()).append(",");			    
		 }
		 jsonRequest.deleteCharAt(jsonRequest.length()-1);
		 jsonRequest.append("\n}");
		 
		 System.out.println("JsonData:"+jsonRequest.toString());
		 
		  try {
				String url = BaseUrl + "/api/v1/"+name;

			  	HttpClient httpClient = HttpClientBuilder.create().useSystemProperties().build();
				
				HttpPost postRequest = new HttpPost(url);
				   	
				postRequest.addHeader("Authorization", "Bearer "+Token);
				StringEntity input = new StringEntity(jsonRequest.toString());
				input.setContentType("application/json");
				postRequest.setEntity(input);
				   	
				System.out.println("Sending Data:"+postRequest.toString());
				//System.out.println("Client Data:"+jsonText);
				HttpResponse response = httpClient.execute(postRequest);
				
				if (response.getStatusLine().getStatusCode() == 401)
					throw new AuthenticationException();
				System.out.println(response.getStatusLine().getStatusCode());
				
				BufferedReader br = new BufferedReader(
                       new InputStreamReader((response.getEntity().getContent())));

				String output;
				StringBuffer resp = new StringBuffer();
				System.out.println("Output from Server .... \n");
				while ((output = br.readLine()) != null) {
					resp.append(output);
				}
				//print result
				//System.out.println(resp.toString());
				//print pretty result		    
				System.out.println(toPrettyFormat(resp.toString()));
				System.out.println("\n\n");
				
				//get all headers
				Header[] headers = response.getAllHeaders();
				for (Header header : headers) {

					System.out.println("Name : " +header.getName()+ " ,Value : " +header.getValue());

				}

		
			  } catch (MalformedURLException e) {

				  throw e;

			  } catch (IOException e) {

				throw e;

			  }
		
	}
	
	/**
	   * Convert a JSON string to pretty print version
	   * @param jsonString
	   * @return
	   */
	  public static String toPrettyFormat(String jsonString) 
	  {
		  try {
			  StringBuilder sb = new StringBuilder();
			  if (jsonString.startsWith("[")) {
				  sb.append("[");
				  JsonParser parser = new JsonParser();
			      JsonElement Element = parser.parse(jsonString);
			      JsonArray jarray = Element.getAsJsonArray();
			      for(int i = 0; i < jarray.size(); i++)
		             {
			    	  		JsonObject json =jarray.get(i).getAsJsonObject();
			    	  		Gson gson = new GsonBuilder().setPrettyPrinting().disableHtmlEscaping().create();
			    		    String prettyJson = gson.toJson(json);
			    		    sb.append(prettyJson);
			    		    if (i != (jarray.size() - 1))
			    		    		sb.append(",").append("\n");
		             }
			      sb.append("]");
			      return sb.toString();
			      
			  } else {
					  
				  JsonParser parser = new JsonParser();
				  JsonObject json = parser.parse(jsonString).getAsJsonObject();
	
				  Gson gson = new GsonBuilder().setPrettyPrinting().create();
				  String prettyJson = gson.toJson(json);
	
				  return prettyJson;
			  }
		  } catch (Exception ex) {
			  
			  System.err.println("Error Occurred while PrettyFormat. " +jsonString);
			  return jsonString;
		  }
	  }
	  
	
	 public static void main(String args[]) throws Exception {
		 
		  try {
				
			  
			  GetRequest("endpoint", "8455445");
			  
			  //GetRequest("sim", "339258");

			  } catch (AuthenticationException e) {

				  authenticate();
				  
			  } catch (IOException e) {

				e.printStackTrace();

			  }
	 }


}
